;
; bank0.asm - bank0 assembler
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

BANK		= 0
		.include config.def
		.include makro.def
		.include consts.def
		.include external.ram
		.include internal.ram

		*= $8000

		.fill $4000,$ff

		*= $a000
		.if DE32_EXISTS=0
config16test	.byte $ff
		.fi
		jmp restore_STOP
		.include crosslnk.asm
		.include restore.asm
		.include jiffydos.asm
		.include dolphindos.asm

		.if ((JIFFYDOS_ACCEL=0) | (SUPERCPU=1)) & (DOLPHINDOS_ACCEL=0)

iectalk		= $ed09
ieclisten	= $ed0c
iecsecond	= $edb9
iectksa		= $edc7
iecout		= $eddd
iecuntalk	= $edef
iecunlisten	= $edfe
iecin		= $ee13

		.fi

		.include lowlevel.asm	;duplicated code!
		.include dos.asm
		.include chrout.asm
		.include chrin.asm
		.include open.asm
		.include chkout.asm
		.include chkin.asm
		.include close.asm
		.include clrchn.asm
		.include save.asm
		.include function.asm
		.include ram.asm	;duplicated code!

buffer_start	.for iodhtoe=0,iodhtoe<MAX_BUFFERS,iodhtoe=iodhtoe+1
		.byte iodhtoe*8+ram_exp_buff_avail0
		.next

		.include misc.asm	;duplicated code!
		.include trap.asm

		*= $8000
		.include boot.asm
		.include c128.asm
		.include selftest.asm
		.include basic.asm
		.include messages.asm	;duplicated code!
		.include math.asm	;duplicated code!
                .include fat.asm
		.include misc2.asm	;duplicated code!

		.if *>$9e60
		.error "Bank0 block $8000-$9e60 over!"
		.fi
