;
; channel15.asm - channel 15 command execution
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
OP_XIT_do_command_channel .proc

		#xit_init

                jsr OP_buffer_start_pom1_y

                .if SUPERCPU=0
                tya
                .fi
		#ldy_l_a buffer_address_low_exp,x
                beq OP_XIT_execute_15command_open.rrts
                .if SUPERCPU=1
                #lda0
                .fi
                sta buffer_address_low_exp,x
		cpy #254
		jsr LWOP_reporterror_32_xit;-=> buffer overflow

		#lda_zp_y pom1
		eor #13			;remove trailing CR
		beq *+3
		iny

                .if SUPERCPU=1
                phx
                .fi
		#lda0			;trailing zero
		.byte SKIP2

thnue		#lda_zp_y pom1		;copy from buffer to path
		dey
		#sta_l_y_x path_exp
		bne thnue
                .if SUPERCPU=1
                plx
                .fi

OP_XIT_execute_15command_open .proc

		lda buffer_drive_exp,x
		sta current_drive_exp

		#xit_init

;		jsr check_drive		;check drive is alive
		jsr LWOP_reporterror_ok

		lda path_exp
		ldx #commandslo-commands
htnuo		cmp commands-1,x
		beq jooocmd
		dex
		bne htnuo
		geq channel15_cont
                
jooocmd		.if SUPERCPU=1
		txa
                asl
                tax
                .else
		lda commandshi-1,x
		pha
		lda commandslo-1,x
		pha
                .fi
		lda path_exp+1
		cmp #"-"
                .if SUPERCPU=1
                jmp (commandslo-2,x)
                .fi
rrts    	rts
;-------------------------------
;C
;
cmd_c		.proc
		cmp #"P"
		bne cmd_cp
		lda path_exp+2          ;cP
in		pha
		jsr XIT_init_drive
                pla
		jsr OP_check_partition_selection;Invalid? -=> error
                jsr LWOP_reporterror_77_xit
		#ldx_l_a current_drive_exp
                tya
		sta drive_workpartition_exp,x
		#adc1
		tax
		ldy #0
                lda #2			;02, PARTITION SELECTED
                sec
		gcs LWOP_reportxy
		.pend
;-------------------------------
;CP change partition
;
; Syntax:
;
;"CP" report working partition
;"CP2" select working partition
;
cmd_cp		.proc
		cmp #"p"
		bne cmd_cd

		jsr OP_get_partnum	;CP
		lda current_path
                gpl cmd_c.in
		.pend
;-------------------------------
;CD change dir
;
;CD:/	- go to root
;CD:<-	- go to parent
;CD:DIR	- go into dir
;
cmd_cd		.proc
		cmp #"d"		;CD hack ;)
		bne ide64
                
re              jsr OP_get_partnum	;CD
		sta path_partition_exp
		bcc jo
                lda path_exp+2
                eor #"/"		;"CD/.......
                bne df
                tax
lp              inx
                lda path_exp+2,x
                sta path_exp-1,x
                bne lp
                geq in

df		eor #95^"/"
		ora path_exp+3
                beq pphack		;"CD<-"
                gne ill
                
jo		lda path_exp+1		;"CD:<-"
		eor #95
                ora path_exp+2
		bne in

pphack  	sta path_exp+2
		lda #"."
		sta path_exp
		sta path_exp+1
		gne in

ide64		jsr OP_get_partnum
		sta path_partition_exp
ill     	bcs LWOP_reporterror_30_xit;-=> error

in		jsr XIT_init_drive	;-=> error
		clc			;there was a colon
                clv			;resolv from working dir
		lda #RESOLV_CD_MODE
		jsr OP_XIT_resolv_path	;-=> path    CD:
                jsr LWOP_reporterror_39_xit;-=> error

		#ldx_l_a partition_currentp_exp	;ok

		ldy #0
bnmf		lda next_sector,y
		sta partition_workdir_exp,x
		inx
		iny
		cpy #4
		bne bnmf
		rts			;-=> OK, exit
		.pend
;-------------------------------
;S remove file
;
cmd_s		.proc
                bne nj
                lda #"s"
                gne channel15_cont
nj
		#lda0
                sta scratch_file_exp
                sta scratch_file_exp+1
                jsr XIT_init_drive
                jsr OP_get_partnum
                pha
                jsr LWOP_reporterror_30_xit
                pla
retry2          clv			;resolv from working dir
                sta path_partition_exp
retry     	lda #RESOLV_S_MODE
		jsr OP_XIT_resolv_path	;-=> path  S:
                bcs notfound    ;file not found
                
                ldx #3
ie		lda resolv_this_sector_exp,x
                sta resolv_this_dir_exp,x
                dex			;continue from this sector next time
                bpl ie

                jsr rewrite_file

		sec
		#inc_l_a scratch_file_exp
                bne retry_same
                #inc_l_a scratch_file_exp+1
                gcs retry_same

notfound	lda path_exp
                #jmps je
kik		jsr OP_short_path
je		beq ende
		cmp #":"
		beq veg
set_v		cmp #","
                bne kik
                jsr OP_short_path
                jsr OP_get_partnum
                bcc retry2
retry_same    	#sev set_v		;resolv from last dir
                gcs retry

veg		sec
		gcs LWOP_reporterror_33_xit

ende
		#ldx_l_a scratch_file_exp
		#ldy_l_a scratch_file_exp+1
                sec
		gcs LWOP_reporterror_01_xit

rewrite_file    .proc			;entry point for "@:"
		jsr XIT_wp

		jsr XIT_is_locked
                sec
                bne LWOP_reporterror_26_xit; other types not done yet

		#cnext next_sector , ram_exp_buffer0_exp

		jsr XIT_kill_entry	;remove directory entry

		lda direntry_f_attrib_exp
		bpl nono		;not closed file, so no freeing

		jsr eraseprepare

		lda #3
		sta scratch_sp_exp
rec_free
		ldy #3
		#ldx_l_a scratch_sp_exp
		cpx #255
		bne ls
		jsr XIT_find_free_flush
nono		rts			;-=> exit

ls		lda ram_exp_buffer0_exp,x
		sta next_sector,y
		dex
		dey
		bpl ls
		#stx_l_a scratch_sp_exp

		lda #ram_exp_tree
		jsr XIT_read_a_sector

		lda #255
		sta scratch_p_exp
		gne in			;free tree sector too

slp		.if SUPERCPU=1
		sta scratch_p_exp
		.else
		lda scratch_p_exp
                .fi
		asl
		asl
		sta pom1
		lda #ram_exp_tree/2
		rol
		sta pom2
		.if SUPERCPU=1
		lda #1
		sta pom3
		.fi

		ldy #3
lw		#lda_zp_y pom1
		sta next_sector,y
		dey
		bpl lw
                jsr next_sector0
		beq null

in		jsr XIT_free_this_sector

null		.if SUPERCPU=1
		lda scratch_p_exp
                inc a
		.else
                inc scratch_p_exp
                .fi
		bpl slp

		.if SUPERCPU=1
		ldy #1
		sty current_path+2
                dey
		.else
		ldy #0
                .fi
		sty current_path
		lda #ram_exp_tree
		sta current_path+1

		lda #8
		sta pom1

ns		ldx #3
mi		#lda_zp_y current_path
		asl
		asl
		asl
		rol next_sector,x
		asl
		rol next_sector,x
		tya
		clc
		adc #4
		tay
		and #15
		bne mi
		dex
		bpl mi
		bcc *+4
		inc current_path+1

		jsr next_sector0
		beq sm

		#phy_a
                ldy #3
                tya
                sec
		adc scratch_sp_exp
		sta scratch_sp_exp
		tax
mr		lda next_sector,y
		sta ram_exp_buffer0_exp,x
		dex
		dey
		bpl mr
		#ply_a

sm		dec pom1
		bne ns
		geq rec_free
		.pend

XIT_kill_entry	.proc
		jsr XIT_posentry

		ldy #$18		;filetype exp
		#lda_zp_y pom1
		and #<~(FTYPE_MASK | FATTR_CLOSED)
in		#sta_zp_y pom1

XIT_writeoutdir	.proc
		lda #ram_exp_dir
		gne XIT_write_a_sector	;first kill entry, than free space
                .pend
                
cmdnotimp	.proc
		sec
		gcs LWOP_reporterror_31_xit;Unknown command
		.pend
;-------------------------------
;P position
;
cmd_p		.proc
		jsr search_channel_A
		bne seekappend.err2

		lda buffer_type_exp,x       ;-=> seeking only for CFS and ISO!
		and #BUFFERMODE_SEEKABLE
                beq seekappend.err2

		lda buffer_info_exp,x
seekappend     	.proc
		ldy #stateless-statenow
ver		cmp statenow-1,y
		beq vy
		dey
		bne ver

err2		sec
		gcs LWOP_reporterror_70_xit

vy		lda #INFO_IGNORE	;be safe
		sta buffer_info_exp,x
                lda buffer_partition_exp,x
                sta partition_currentp_exp

		lda statewhat-1,y
                sta path_exp		;state
		bpl vdrs		;buffer is not dirty

		#phy_a
		jsr update_filelen
		jsr XIT_flush_buf
		#ldx_l_a buffer_currentp_exp
		#ply_a
vdrs
		lda path_exp+2
		cmp buffer_filesize1_exp,x
		lda path_exp+3
		sbc buffer_filesize2_exp,x
		lda path_exp+4
                sta buffer_filepos3_exp,x
                sta next_sector+2
		sbc buffer_filesize3_exp,x
		lda path_exp+5
                sta buffer_filepos4_exp,x
                sta next_sector+1
		sbc buffer_filesize4_exp,x

		lda stateless-1,y
		bcc less
                .if EXPERIMENTAL=0
		lda buffer_filesize1_exp,x
		sta path_exp+2
		lda buffer_filesize2_exp,x
		sta path_exp+3
		lda buffer_filesize3_exp,x
		sta path_exp+4
                sta buffer_filepos3_exp,x
                sta next_sector+2
		lda buffer_filesize4_exp,x
		sta path_exp+5
                sta buffer_filepos4_exp,x
                sta next_sector+1
                .fi
		lda stateend-1,y	;reached eof
less		pha

		lda buffer_address_max_hi_exp,x
                clc
                sbc buffer_start,x
                pha
                eor #$ff
		and path_exp+3
		sta buffer_filepos2_exp,x
                sta next_sector+3
                
		pla
		and path_exp+3
                sta path_exp+3
		ora path_exp+2
                tay
		beq fer			;buffer start?
                
		lda buffer_type_exp,x
		cmp #BUFFERMODE_ISOFILE
		bne cfs
                
		ldy #3      
ry              lsr next_sector+1
                ror next_sector+2
                ror next_sector+3
                dey
                bne ry
                sty next_sector

                txa
                asl
                asl
                tax
                ldy #3
ro              lda next_sector,y
                adc buffer_isofile_start_exp,x
                sta next_sector,y
                inx
                dey
                bpl ro

                jsr OP_buffer_start
                jsr XIT_read_a_sector
                #jmps dddd

cfs		jsr XIT_init_drive	;-=> error
		lda path_exp		;state?
		beq rrd
		jsr XIT_save_tree	;-=> error
		#jmps tr

rrd		jsr XIT_load_tree	;-=> error

tr		sec			;force clear
		jsr XIT_read_in_buffer	;-=> error

dddd		#ldx_l_a buffer_currentp_exp

		lda buffer_filesize1_exp,x
		sec
		sbc #1
		tay
		lda buffer_filesize2_exp,x
		sbc buffer_filepos2_exp,x
		sta pom2
		lda buffer_filesize3_exp,x
		sbc buffer_filepos3_exp,x
		bne more
		lda buffer_filesize4_exp,x
		sbc buffer_filepos4_exp,x
		bcc more
		bne more

		lda buffer_address_max_hi_exp,x
;		sec
		sbc buffer_start,x
		clc
		sbc pom2
		bcc more

		lda pom2
		ora buffer_start,x
                gcs fer

more		ldy #0
		lda buffer_address_max_hi_exp,x
fer     	sta buffer_address_end_hi_exp,x
		tya
		sta buffer_address_end_low_exp,x

		lda path_exp+2
		sec
		sbc #1
		sta buffer_address_low_exp,x
		lda path_exp+3
		sbc #0
		clc
		adc buffer_start,x
		cmp buffer_address_end_hi_exp,x
		bne krk
                pha
                lda buffer_address_low_exp,x
                cmp buffer_address_end_low_exp,x
                pla
                bcs krk
		ora #$80
krk		sta buffer_address_hi_exp,x

		pla
		sta buffer_info_exp,x
		rts				;-=> exit, OK

statenow	.byte INFO_BLK_READ ,INFO_BLK_R_EOF,INFO_BLK_WRITE,INFO_BLK_WRITE_DIRTY,INFO_BLK_RW    ,INFO_BLK_RW_EOF,INFO_BLK_RW_DIRTY,INFO_BLK_RW_EOF_DIRTY
stateless	.byte INFO_BLK_READ ,INFO_BLK_READ ,INFO_BLK_WRITE,INFO_BLK_WRITE      ,INFO_BLK_RW    ,INFO_BLK_RW    ,INFO_BLK_RW      ,INFO_BLK_RW
stateend	.byte INFO_BLK_R_EOF,INFO_BLK_R_EOF,INFO_BLK_WRITE,INFO_BLK_WRITE      ,INFO_BLK_RW_EOF,INFO_BLK_RW_EOF,INFO_BLK_RW_EOF  ,INFO_BLK_RW_EOF
statewhat	.byte 0             ,0             ,1             ,128                 ,1              ,1              ,128              ,128
		.pend
;-------------------------------
;M make dir
;
;"MD:NEW"
;
cmd_m		.proc
                bne nj
                lda #"m"
                gne channel15_cont

nj              lda #RESOLV_MD_MODE
		jsr OP_XIT_resolv_path_part_init;-=> error  MD:
		bcs jo
		sec
		gcs LWOP_reporterror_63_xit;-=> file exists
jo
		#lda0
		sta path_searchtype_exp
		lda #ram_exp_bitmap
                ldx #"/"
                clc
                clv
		jsr XIT_prealloc_dir_sector;-=> error

		lda #FIND_FREE_METADATA
		jsr find_free_space	;allocate dir sector

		#lda0
		tax
nw		sta ram_exp_buffer0_exp,x
		sta ram_exp_buffer0_exp+$100,x
		inx
		bne nw

		tay
ii2		#lda_l_y path_exp	;fill in filename
		beq vt
		iny
		.byte SKIP2
vt		lda #32
		sta ram_exp_buffer0_exp,x
		inx
		cpx #16
		bne ii2

		ldx #3
ns		lda cdir,x
		sta ram_exp_buffer0_exp+$18,x;type & attrib
		lda next_sector,x
		sta ram_exp_buffer0_exp+$10,x;pointer
                sta created_new_dir_sector_exp,x;for finalize_direntry
		lda resolv_this_dir_exp,x
		sta ram_exp_buffer0_exp+$14,x;parent
		dex
		bpl ns
                and #%01001111
                sta ram_exp_buffer0_exp+$14;pointer
                lda next_sector
                and #%01001111
		sta ram_exp_buffer0_exp+$10;pointer
                
                lda #ram_exp_buffer0
                jsr init_pom1_y
                jsr OP_timestamp	;update timestamp

		lda #ram_exp_buffer0	;write out new dir sector
		jsr XIT_write_a_sector	;-=> error

		jsr XIT_find_free_flush	;-=> error

		ldx #2
sw		lda cdir+1,x
		sta path_searchtype_exp,x
		#lda0
		sta szam,x
		dex
		bpl sw
		sta szam+3

		lda #FTYPE_DIR | FATTR_EXEC | FATTR_READ | FATTR_WRITE | FATTR_DELETE | FATTR_CLOSED
                sec
		gcs XIT_finalize_direntry	;-=> exit, OK

cdir		.byte FTYPE_DIR | FATTR_EXEC | FATTR_READ | FATTR_WRITE | FATTR_DELETE,"dir"
		.pend
;-------------------------------
;"R-H:NEW" rename header
;"R-P:NEW=OLD" rename partition
;
cmd_r		.proc
                bne jfj
                lda path_exp+2
                cmp #"h"
                bne rename

		lda #RESOLV_RH_MODE
		jsr OP_XIT_resolv_path_part_init;-=> error  R-H:
                
                lda #ram_exp_dir
		jsr XIT_read_a_sector	;read in dir sector

		lda ram_exp_dir_exp+$18
                sta resolv_dirattrib_exp
		and #FTYPE_MASK | FATTR_CLOSED
		eor #FTYPE_DIR
                tax
                cmp #1
		jsr LWOP_reporterror_71_xit;-=> directory error
                
                jsr XIT_wp

		ldy #$f0
jf              lda path_exp,x
                bne *+5
en              dex
                lda #32
                cmp #","
                beq en
                #sta_l_y ram_exp_dir_exp-$f0
                inx
                iny
                bne jf
		geq XIT_writeoutdir     ;-=> exit, OK  write out dir sector

jfj             cmp #"d"
                beq cmd_rd
;-------------------------------
; R rename or move
;
;"R/DEST/:NEW=/SOURCE/:OLD"
;
rename		.proc
		jsr XIT_init_drive
                jsr OP_get_partnum
                sta path_partition_exp
                pha
missing         jsr LWOP_reporterror_30_xit

		sec
		ldx #255
jj              inx
		lda path_exp,x
                beq missing
                sta ram_exp_dir_exp,x
                eor #"="
                bne jj
                sta ram_exp_dir_exp,x
                ldy #255
clp             inx
                iny
                lda path_exp,x
                #sta_l_y path_exp
                bne clp

		jsr OP_get_partnum
                bcs krk			;not given, use the previous
                sta path_partition_exp
krk             clv			;Resolv from working dir
                lda #RESOLV_R2_MODE
                jsr OP_XIT_resolv_path	;-=> error  R:

		jsr XIT_wp		;source writable?
                
                jsr XIT_is_locked	;locked?
                
                pla
                sta path_partition_exp
                
                jsr XIT_posentry	;dir sector needed
                lda pom2
                eor #ram_exp_dir^ram_exp_tree
                sta pom2
                
                clc
                ldx #255
jj2		inx
                lda ram_exp_dir_exp,x
                sta path_exp,x
                beq cc
                eor #","
                bne jj2
                sec
                gcs jj2
cc
		bcs volt
                
                ldy #$18
                lda #","
                .byte SKIP2
idk             #lda_zp_y pom1		;append original type
                sta path_exp,x
                inx
                iny
                cpy #$1c
                bcc idk
                #lda0
                sta path_exp,x
volt
		#psz pom1

                lda partition_currentp_exp
                pha
                ldy #$17
	        ldx #3
p2              lda resolv_this_dir_exp,x
		pha
                #lda_zp_y pom1
		sta rename_old_dir_exp,x
                lda next_sector,x
                sta rename_old_dirsect_exp,x
                dey
                dex
                bpl p2

		lda #RESOLV_R_MODE
                clc			;after colon
                clv			;from working dir
		jsr OP_XIT_resolv_path	;-=> error  R:
		bcs jo
		sec
		gcs LWOP_reporterror_63_xit;-=> file exists

invl		.text "delreldirlnk"

jo
		ldy #255
is              iny
		#lda_zp_y current_path
                beq jr
                eor #","
                bne is
                #sta_zp_y current_path
jr                
                ldx #$fc
                clc
p2e             pla
		eor resolv_this_dir_exp-$fc,x
                beq *+3
                sec
                inx
                bne p2e
                #sev set_v                  ;check filename only
                pla
                bcc same_directory
                eor partition_currentp_exp
                bne LWOP_reporterror_39_xit;different partition, sorry
                clv			    ;allocate new dir sector if needed
same_directory	
		php
                ldx #0
                lda setup_atribut2_exp
                bmi *+4
                ldx #"/"
		lda #ram_exp_bitmap
                clc
		jsr XIT_prealloc_dir_sector

		plp
		pla
                sta current_path
                pla 
                sta current_path+1
                .if SUPERCPU=1
                lda #1
                sta current_path+2
                .fi
                php

		ldx #0
		#txy_a
ii		lda path_exp,x		;fill in filename
		beq *+3
		inx
		#sta_zp_y current_path
		iny
set_v	 	cpy #$10
		bcc ii

		#sev set_v
		ldx #0
		ldy #$19
scw		lda path_searchtype_exp,x
		beq *+3
                inx
                #cmp_zp_y current_path
                beq *+3
                clv
                #sta_zp_y current_path 	;fill in filetype
		iny
		cpy #$1c
		bcc scw
                bvs kih2		;filetype unchanged?

                ldx #11
xjj             sec
		ldy #$1b
iei             #lda_zp_y current_path
                eor invl,x
                beq *+3
                clc
                dex
                dey
                tya
                eor #$18
                bne iei
                bcs invt		;invalid type
xj		txa
		bpl xjj
;                clv
kih2
		ldy #$18
                #lda_zp_y current_path
                and #FTYPE_MASK | FATTR_CLOSED
                cmp #FTYPE_DIR
                beq LWOP_reporterror_26_xit;do not rename dirlabel
                and #FTYPE_MASK
                cmp #FTYPE_NORMAL
                beq thd			;regular file?
                sec
invt            bvc LWOP_reporterror_64_xit;rename of a reserved type! (eg. dir to prg)
thd
                plp
                bcs diffdir
                
writeold        #cnext rename_old_dirsect_exp, next_sector
		lda #ram_exp_tree
                jmp XIT_write_a_sector	;same directory, no problem

diffdir		jsr XIT_posentry 

                ldy #$14
                .if SUPERCPU=1
                lda [pom1],y
                tax
                .else
                lax (pom1),y
                .fi
                ldy #31
ksk             #lda_zp_y current_path
                #sta_zp_y pom1
                dey
                bpl ksk
                txa
                ldy #$14
                #eor_zp_y current_path
                and #%00110000
                #eor_zp_y current_path
                #sta_zp_y pom1		;do not destroy directory link!

                clc
                ldy #$18
                #lda_zp_y current_path
                pha
                and #<~(FATTR_CLOSED | FTYPE_MASK);remove file
                #sta_zp_y current_path
                pla
                pha
                and #<~FATTR_CLOSED
		#sta_zp_y pom1
                and #FTYPE_MASK
                eor #FTYPE_DIR
                bne sf
                sec
                #lda_zp_y current_path
                #sta_zp_y pom1	   	;remove
sf		php
		bcc ndir0

                #cnext resolv_this_dir_exp, next_sector
                
nrootdir        lda #ram_exp_buffer0
                jsr XIT_read_a_sector

		#sev set_v
                sec
                ldx #$0
                #txy_a
ir              lda next_sector,x
                eor rename_old_dir_exp,x
                bcc do
                and #%01001111
do		beq *+3
		tay
		lda ram_exp_buffer0_exp+$14,x
		sta next_sector,x
                eor ram_exp_buffer0_exp+$10,x
                bcc do2
                and #%01001111
do2		beq *+3
		clv
		inx
                cpx #4
                bcc ir
                tya
                beq LWOP_reporterror_39_xit;no loops please...
                bvc nrootdir

ndir0           jsr XIT_write_new     	;write non-closed destination
                plp
                php
                bcc ndir1

		jsr dirc
                jsr XIT_read_a_sector	;read in directory's first sector
ndir1
		jsr writeold		;remove old file
                plp                     ;if we crash here then say
                bcc ndir2               ;goodbye to your data...

                ldx #3
jje             lda resolv_this_dir_exp,x
                sta ram_exp_buffer0_exp+$14,x
                dex
                bne jje
                lda ram_exp_buffer0_exp+$14
                eor resolv_this_dir_exp
                and #%10110000		;do not destroy directory link!
                eor resolv_this_dir_exp
                sta ram_exp_buffer0_exp+$14

                jsr dirc
                jsr XIT_write_a_sector  ;write out directory's first sector

ndir2           jsr XIT_posentry.in
                pla			
                ldy #$18
                #sta_zp_y pom1 		;write out new entry again

XIT_write_new 	#cnext resolv_empty_entry_exp, next_sector
                jmp XIT_writeoutdir     ;write non-closed destination

dirc            ldy #$14
iic             #lda_zp_y current_path
                sta next_sector-$14,y
                iny
                cpy #$18
                bcc iic
                lda #ram_exp_buffer0
		rts
		.pend
;-------------------------------
;RD rmdir
;
cmd_rd		.proc
		lda #RESOLV_RD_MODE
		jsr OP_XIT_resolv_path_part_init;-=> error  RD:
re              ldx #0
		bcs filenotf		;-=> file not found

		jsr XIT_wp

		lda direntry_f_attrib_exp
		and #FATTR_DELETE | FTYPE_MASK | FATTR_CLOSED
		eor #FATTR_DELETE | FTYPE_DIR | FATTR_CLOSED
		bne LWOP_reporterror_26_xit;write protected
                
                sec
                ldy #3
                tya
		ora partition_currentp_exp;ok
                tax
lk              lda next_sector,y
                pha
		eor partition_workdir_exp,x
                beq *+3
                clc
                dex
                dey
                bpl lk
                bcs LWOP_reporterror_60_xit  ;cannot remove the working directory

;		clc
		jsr XIT_test
                
                jsr XIT_kill_entry	;remove directory entry

		jsr eraseprepare

		ldx #0
ll		pla
                sta next_sector,x
                inx
		cpx #4
		bcc ll

;               sec
                jsr XIT_test
		jsr XIT_find_free_flush
                ldx #1
filenotf        ldy #0
                sec
                gcs LWOP_reporterror_01_xit
                
XIT_test       	#lda0
		sta current_path
                .byte SKIP1
lo		plp
                php
                bcc sk

		ldx #3
le              lda next_sector,x
                pha
                dex
                bpl le

                jsr XIT_free_this_sector

		ldx #0
le2             pla
                sta next_sector,x
                inx
                cpx #4
                bne le2

sk
		jsr OP_read_cmd1
                bcs broken		;disk error...

                ldy #15
nj2             ldx #11
nj              lda data_g
                dex
                bne nj
                .if FAST_DATA_TRANSFERS=1
                pha
                .fi
                tya
                lsr
                lsr
                tax
                .if FAST_DATA_TRANSFERS=1
                pla
                .else
                lda low_reg
                .fi
                asl
		asl
		asl
		rol next_sector,x
		asl
		rol next_sector,x
		bit data_g
		lda data_g
                #lda_low_reg
                and #FATTR_CLOSED | FTYPE_MASK
                beq xjx
                cmp #FTYPE_DIR
                beq xjx
                sec
                rol current_path
xjx             bit data_g
                bit data_g
                bit data_g
                dey
                bpl nj2

		jsr ata_pi_nomore_data
                bcc ok2			
broken          plp                     ;disk error...
		tax
                lda direct_write_exp
                beq errr                ;no direct write, no remove...
                bcc problem
errr		txa
		sec
		gcs LWOP_reporterror_read_xit	;-=> error

ok2             plp
                php
                bcs sk2

                lda current_path
                sec
                bne re				;non-empty directory
sk2
		jsr next_sector0
                bne lo
                plp
problem         rts
		.pend
;-------------------------------
;L lock
;
cmd_l		.proc
		lda #RESOLV_L_MODE
		jsr OP_XIT_resolv_path_part_init;-=> error  L:

		jsr XIT_wp

                ldy #$fc
kfj             #lda_l_y_ direntry_f_pointer_exp-$fc
                eor partition_del_dir_exp,x
                bcc *+5
                and #%01001111
                clc
                bne mas
                inx
                iny
                bne kfj
                rts			;-=> exit, OK  ignore
mas
		jsr XIT_posentry

		ldy #$18		;filetype exp
                .if SUPERCPU=1
                lda [pom1],y
                tax
                .else
                lax (pom1),y
                .fi
                and #FTYPE_MASK | FATTR_CLOSED
                cmp #FTYPE_DIR
                beq LWOP_reporterror_62_xit; dirlabel?!
		txa
                bit i			;write and delete cleard?
                beq set
                and #<~(FATTR_WRITE | FATTR_DELETE)
                .byte SKIP2
set             ora #FATTR_WRITE | FATTR_DELETE
		bit i2			;DEL file?
                bne *+4
                and #<~(FATTR_READ | FATTR_WRITE | FATTR_EXEC)
		pha
                jsr XIT_kill_entry.in
                pla
                pha
                and #FTYPE_MASK
                cmp #FTYPE_DIR
                bne notdir

                #cnext direntry_f_pointer_exp , next_sector

                lda next_sector
                asl
                php

                lda #ram_exp_dir
		jsr XIT_read_a_sector	;read in dir sector
                
                lda ram_exp_dir_exp+$14
                asl
                plp
                ror
                sta ram_exp_dir_exp+$14	;copy hidden

                pla
                and #<~(FATTR_CLOSED)
                sta ram_exp_dir_exp+$18	;copy attr

		jmp XIT_writeoutdir     ;-=> exit, OK write out dir sector

notdir		pla
		rts			;-=> exit, OK
                
i               .byte FATTR_WRITE | FATTR_DELETE
i2		.byte FTYPE_MASK
                .pend
;-------------------------------
;Free the next_sector in bam
;
XIT_free_this_sector .proc
                jsr chs2lba

                jsr boundend
                bcs qu

		lda szam+0
		sec
		sbc find_free_start_exp+0
		pha
		#stz_a szam+0
		lda szam+1
		sbc find_free_start_exp+1
		pha
		and #$f0
		sta szam+1
		lda szam+2
		sbc find_free_start_exp+2
		sta szam+2
		lda szam+3
		sbc find_free_start_exp+3
		sta szam+3
                bcs ok
		pla
		pla
qu		rts			;no access beyond partition...

ok      	ldx #3
ce		lda szam,x
		cmp scratch_now_exp,x
		bne vw
		dex
		bne ce
		geq ncw

vw
		ldx #0
		lda find_free_bam_exp
		lsr
		ldy #3
li		lda szam,x
		sta scratch_now_exp,x
		adc find_free_start_exp,x
		pha
		inx
		dey
		bpl li
                
		jsr XIT_find_free_flush

		ldx #3
li2             pla
                sta szam,x
                sta find_free_now_exp,x
                dex
                bpl li2

                jsr isbamlocked
                lda buffer_start,x
                ora #>b_cfs_file_bitmap_exp	;modify bam directly in file's bam
		bcs *+4
                lda #ram_exp_bitmap		;modify bam in own buffer
                sta find_free_buf_exp+1
                bcs noread

		jsr readinbam.in

noread          lda #1
                sta find_free_dirty_exp

ncw		pla
		and #$0f
		sta pom2
		pla
                .if SUPERCPU=1
		tay
		and #7
		tax
		tya
                .else
                ldx #7
                sbx #0
                .fi

		lsr pom2
		ror
		lsr pom2
		ror
		lsr pom2
		ror
		sta pom1
                lda find_free_buf_exp+1
		#orasta_a pom2
		.if SUPERCPU=1
		lda #1
		sta pom3
		lda [pom1]
		ora bm,x
		sta [pom1]
		.else
		ldy #0
		lda (pom1),y
		ora bm,x
		sta (pom1),y
		.fi
                rts
                
bm		.byte %10000000
		.byte %01000000
		.byte %00100000
		.byte %00010000
		.byte %00001000
		.byte %00000100
		.byte %00000010
		.byte %00000001
                .pend
;-------------------------------
;Read in directory sector and position on file (scratch, rename)
;
XIT_posentry 	.proc
		#cnext resolv_this_sector_exp , next_sector

in		lda resolv_entry_offs_exp
in2		lsr
		ror
		ror
		ror
		sta pom1
		lda #ram_exp_dir/2
		rol
		sta pom2
		.if SUPERCPU=1
		lda #1
		sta pom3
		.fi
		rts
                .pend
;-------------------------------
;Check nonexistent filename and if partition is writeable
;
XIT_wp		.proc
		.if SUPERCPU=1
                jsr OP_get_current_drive_type
                .else
		ldx current_drive_exp
                .fi
                lda drive_allowwrite_exp,x
                beq wp 		;write protected drive

		#ldx_l_a partition_currentp_exp
		lda partition_start_exp,x
		and #PATTR_WRITEABLE
	      	beq wp			;write protected partition

		lda resolv_dirattrib_exp
                and #FATTR_WRITE
wp              sec
		beq LWOP_reporterror_26_xit;write protected directory
                rts
		.pend			;X=partition_currentp_exp, C=1!!!
;-------------------------------
;Common prepare for S and RD
;
eraseprepare	.proc
		#ldx_l_a partition_currentp_exp
		lda partition_root_dir_exp,x
                asl
		lda #FIND_FREE_DATA
                sta find_free_mode_exp	;important!
		#lda0
                sta find_free_dirty_exp
                rol
                sta find_free_bam_exp

		ldx #3
		lda #255
ll      	sta scratch_now_exp,x
		dex
		bpl ll
                gmi partitionboundprepare
                .pend
;-------------------------------
;Is file locked?
;
XIT_is_locked	.proc
		lda direntry_f_attrib_exp
		and #FATTR_DELETE | FTYPE_MASK
		eor #FATTR_DELETE | FTYPE_NORMAL
                bne notsupp
                
                ldx #MAX_BUFFERS-1
leu             lda buffer_logical_exp,x
                beq nopen		;buffer valid?
                lda buffer_drive_exp,x
                cmp current_drive_exp
                bne nopen		;on this drive?
                lda buffer_type_exp,x
                cmp #BUFFERMODE_FILE
                bne nopen               ;used for file?

		lda #>b_cfs_file_state_exp
		jsr buffer_subpart_cp2

                #phx_a

		ldy #<(b_cfs_file_state_exp+cfs_file_treeroot_exp-cfs_file_info_backup_start_exp+3);check treeroot
		ldx #3
uiy2		#lda_zp_y current_path
		eor direntry_f_pointer_exp,x
                cpx #1
                bcs *+4
                and #$4f
                and #$ff
                bne nun
		dey
		dex
		bne uiy2
                sec                
                gcs LWOP_reporterror_60_xit;opened files can't be deleted!

nun             #plx_a
nopen		dex
		bpl leu
                inx
notsupp		rts
                .pend
;-------------------------------
search_channel_A .proc
		tax
exit    	ora #$60		;rts!
		sta pom2
                dex
                dex
		cpx #15-2
                jsr LWOP_reporterror_70_xit;error if not 2-14

		#ldx_l_a buffer_currentp_exp;channel 15's buffer
		lda buffer_logical_exp,x
		ldx #MAX_OPEN_FILES
lp		dex
		bmi exit+1
		cmp open_files_logical_exp,x
		bne lp
		lda open_files_device_exp,x;now we have the drivenumber we are on
		sta pom1
		ldx #MAX_OPEN_FILES
lp2		dex
		bmi exit+1
		lda pom1
		cmp open_files_device_exp,x;on this drive?
		bne lp2
		lda pom2
		cmp open_files_secondary_exp,x;channel correct?
		bne lp2
		lda open_files_logical_exp,x;file open?
		beq lp2
		gne search_buffer_A
		.pend
;V validate
;I initialize
;/ path (1581)
;M memory
;  MD mkdir
;  M-R memory read
;  M-W memory write
;  M-E memory execute
;B block
;  B-A block allocate
;  B-F block free
;  B-R block read
;  B-W block write
;  B-E block execute
;  B-P block pointer
;  B-r ??
;  B-w ??
;U user
;  U1 read
;  U2 write
;  U3-U8 user stuff
;  U9 identify
;  U: reset
;  U0 no operation, restore Ux jump table
;  U0>C ??
;  U0>T Teszt
;  U0>B Fast serial
;  U0>V0 Verify off
;  U0>V1 Verify on
;  U0>R Retry count
;  U0>S Interleave
;  U0>M0 1541 mode 
;  U0>M1 1571 mode 
;  U0>H0 Side 0
;  U0>H1 Side 1
;  U0>MR Burst memory read
;  U0>MW Burst memory write
;  U0>drivenumber
;P pointer
;& utility
;C 
;  C copy
;  CP change partition
;  Cp change partition
;  CD chdir
;R
;  R rename
;  RD rmdir
;  R-H rename header
;  R-P rename partition
;S 
;  S scratch
;  S-8 switch 8
;  S-9 switch 9
;  S-D switch default
;  S-C scsi command
;N new
;G get
;  GEOS ?
;  G-D ?
;  G-P get partition
;L lock
;W
;  W-0 Write protect off
;  W-1 Write protect on
;T time
;  T-RA read time ascii
;  T-RB read time bcd
;  T-RD read time decimal
;  T-WA write time ascii
;  T-WB write time bcd
;  T-WD write time decimal
;D duplicate

commands	.text "pcmsrl"
		.if SUPERCPU=1
commandslo	.word cmd_p
		.word cmd_c
		.word cmd_m
		.word cmd_s
                .word cmd_r
                .word cmd_l
                .else
commandslo	.byte <(cmd_p-1)
		.byte <(cmd_c-1)
		.byte <(cmd_m-1)
		.byte <(cmd_s-1)
                .byte <(cmd_r-1)
                .byte <(cmd_l-1)
commandshi	.byte >(cmd_p-1)
		.byte >(cmd_c-1)
		.byte >(cmd_m-1)
		.byte >(cmd_s-1)
                .byte >(cmd_r-1)
                .byte >(cmd_l-1)
                .fi
